function w = cluster_within(A,c)
  % Calculate diag(c'*A*c)
  w = zeros(1,size(c,2));
  batch_size = min(1e3, size(c,2));
  for col=1:ceil(size(c,2) / batch_size)
    if batch_size == 1
      % faster multiplication algorithm, but only for single clusters
      [i,~,k] = find(c(:,col));
      if length(k)<10000
        w(col) = full(diag( c(:,col)'*(A(:,i)*k) ))';
      else
        w(col) = full(diag( k'       *(A(i,i)*k) ))';
      end
    elseif 1
      % The faster algortithm: restrict the graph to nodes occuring in the clusters in the batch
      cols = (col-1)*batch_size+1 : min(col*batch_size,length(w));
      [i,j,k] = find(c(:,cols));
      [ui,uip,uii] = unique(i);
      cc = sparse(uii,j,k);
      w(cols) = full(sum(cc.*(A(ui,ui)*cc),1));
    else
      cols = (col-1)*batch_size+1 : min(col*batch_size,length(w));
      w(cols) = full(sum(c(:,cols).*(A*c(:,cols)),1));
    end
  end
end
