function out = compare_cluster_summary(A,cFound,cSeed,cInit,cTruth)
  % summary statistics of comparing cluster cfound to truth cTruth
  d = full(sum(A));
  
  out = struct( ...
    'truth', cluster_summary(A,d,cTruth), ...
    'found', cluster_summary(A,d,cFound), ...
    'seed',  cluster_summary(A,d,cSeed), ...
    'init',  cluster_summary(A,d,cInit), ...
    'found_vs_truth', cluster_pair_summary(cFound,cTruth), ...
    'found_vs_seed',  cluster_pair_summary(cFound,cSeed) ...
    );
end

function out = cluster_summary(A,d,c)
  [i,~,k] = find(c);
  if length(k)<10000
    out.within = full(diag( c'*(A(:,i)*k) ))';
    out.within_nz = full(diag( (c>0)'*(A(:,i)*(k>0)) ))';
    out.within_th = full(diag( (c>=0.5)'*(A(:,i)*(k>=0.5)) ))';
  else
    out.within = full(diag( k'*(A(i,i)*k) ))';
    out.within_nz = full(diag( (k>0)'*(A(i,i)*(k>0)) ))';
    out.within_th = full(diag( (k>=0.5)'*(A(i,i)*(k>=0.5)) ))';
  end
  out.sum    = sum(c);
  out.sumsq  = sum(c.^2);
  out.nnz    = nnz(c);
  out.nnz_th = nnz(c >= 0.5);
  out.volume = full(d*c);
  out.volume_nz = full(d*(c>0));
  out.volume_th = full(d*(c>=0.5));
end

function out = cluster_pair_summary(c1,c2)
  out.sum_min  = full(sum(min(c1,c2)));
  out.sum_max  = full(sum(max(c1,c2)));
  out.sum_prod = full(sum(c1 .* c2));
  out.nnz_min  = full(nnz(min(c1,c2)));
  out.nnz_th_min = full(nnz(min(c1,c2) >= 0.5));
  out.f1 = cluster_overlap_f1(c1,c2);
end
