function y = index_transposed_struct(x,idx)
  % get an index from a transposed_struct
  % index_transposed_struct(transpose_struct(xs),i) = xs{i}
  if isnumeric(x) && length(x)>1
    y = x(idx);
  elseif isnumeric(x) || ischar(x)
    y = x;
  elseif isstruct(x)
    fn = fieldnames(x);
    y = struct();
    for i=1:numel(fn);
      xi = getfield(x, fn{i});
      yi = index_transposed_struct(xi, idx);
      y = setfield(y, fn{i}, yi);
    end
  else
    error('index_transposed_struct');
  end
end
