function sigma=min_sigma(A,c,d)
  % Calculate the minimal value of sigma needed to make c a local optimum (with lambda=sigma)
  [i,j,k] = find(c);
  v = full(d*c);
  w = full(diag( c'*(A(:,i)*k) ))';
  n = sum(c);
  v2 = full(d*(c.^2));
  dv = d';
  dr0 = (2*A*c)./(v+eps) - dv*(w)/(v+eps).^2;
  drs = (2*c.*d')./(v+eps) - dv*v2/(v+eps).^2;
  % dr = dr0 + sigma*drs
  % want dr>=0 for all nodes in c, dr<=0 for everything not in c
  %min_sigma_pos = max( -dr0(i) ./ drs(i) );
  %min_sigma_neg = max( dr0 ./ drs );
  %sigma = max(0,min_sigma_pos)
  sigma = max(-dr0 ./ drs);
end
