function [cBest,sBest] = optimize_cluster_hkgrow_neighbors(A,cSeed)
  addpath([pwd '/../hkgrow']);
  n = find( cSeed | (sum(A(:,find(cSeed)),2) > 0) );
  seeds = find(cSeed);
  cBest = cSeed;
  sBest = 1;
  for i=n(:)'
    assert(numel(i)==1);
    [c,s] = hkgrow(A,i);
    %[c,s] = hkgrow(A,union(seeds,i));
    c = union(c,seeds); % always include seed
    c = sparse(c,1,1, length(A),1);
    s = 1 - score_conductance(A,c); % the recalculate conductance
    if s < sBest
      cBest = c;
      sBest = s;
    end
  end
end
