function out = optimize_cluster_summary(A,c0,varargin)
  % optimize a cluster, return only summary statistics (for memory reasons)
  [c1,l] = optimize_cluster(A,c0,varargin{:});
  
  d = full(sum(A));
  [i,unused,k] = find(c1);
  if length(k)<10000
    w = full(diag( c1'*(A(:,i)*k) ))';
  else
    w = full(diag( k'*(A(i,i)*k) ))';
  end
  v = full(d*c1);
  
  out = struct(
    'nnz',nnz(c1),
    'sum0',full(sum(c0)),
    'sum',full(sum(c1)),
    'max',full(max(c1)),
    'sum_min',full(sum(min(c0,c1))),
    'sum_max',full(sum(max(c0,c1))),
    'volume',v,
    'within',w,
    'score',l,
    'f1',cluster_overlap_f1(c0,c1)
    );
end
