function c = random_cluster(A,k,seed)
  % Generate a random cluster of size k by starting at a random node, and adding random neighbors
  if nargin >= 3
    srand(seed);
  end
  for restart = 1:1000
    i = randi(length(A));
    while sum(A(:,i)) == 0
      i = randi(length(A));
    end
    c = sparse(i,1,1,length(A),1);
    % add neighbors
    for n=2:k
      should_restart = 1;
      for rep=1:10000
        j = i(randi(length(i)));
        us = find(A(:,j));
        u = us(randi(length(us)));
        if ~c(u)
          c(u) = 1;
          i = [i,u];
          should_restart = 0;
          break;
        end
        if rep==50
          % test size of connected component
          c2 = A*c | c;
          if isequal(find(c),find(c2)) && nnz(c2) < k
            should_restart = 1;
            break;
          end
        end
      end
      if should_restart
        if restart == 100
          warning('Failed to find a neighbor, size is %d',n-1);
        end
        break;
      end
    end
    if ~should_restart
      return
    end
  end
  error('Failed to find a neighbor');
end
