function [R,C] = random_seeds_geornd(CAll, num_clus, max_size, seed)
  % Get random seed with different sizes
  % Protocol of
  % 1. randomly pick a community c following the uniform distribution.
  % 2. randomly pick an n following the shifted geometric distribution geornd(0.6).
  % 3. If n \leq min{|c|, 40}, success; otherwise, this trial fails and we need to begin a new one.
  % return num_clus clusters in total.
  
  if nargin>=3 && seed>=0
    srand(seed);
  elseif nargin<3 || seed==0
    srand(1);
  end
  
  C = sparse(size(C,1),0);
  R = sparse(size(C,1),0);
  while size(C,2) < num_clus
    c = randperm(size(CAll,2),1);
    n = geornd(0.6) + 1;
    if n <= min(sum(CAll(:,c)), max_size)
      C(:,end+1) = CAll(:,c);
      R(:,end+1) = random_seeds(CAll(:,c),n,-1);
    end
  end
end

