function y = transpose_struct(x)
  % transpose a cell-of-structs into a struct-of-arrays (perhaps nested)
  if isempty(x)
    error('Don''t know how to transpose an empty cell array');
  end
  fn = fieldnames(x{1});
  y = struct();
  for i=1:numel(fn);
    allhave = all(cellfun(@(x)isfield(x,fn{i}),x,'UniformOutput',true));
    if ~allhave, continue; end
    if isnumeric(getfield(x{1},fn{i}))
      value = cellfun(@(x)full(getfield(x,fn{i})),x,'UniformOutput',true);
    else
      value = cellfun(@(x)getfield(x,fn{i}),x,'UniformOutput',false);
      if isstruct(getfield(x{1},fn{i}))
        value = transpose_struct(value);
      end
    end
    y = setfield(y,fn{i},value);
  end
end
